gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.StyleProperties

Contents

- Exported types
- Methods
  - clear
  - getProperty
  - lookupColor
  - mapColor
  - merge
  - new
  - setProperty
  - unsetProperty

Description

GtkStyleProperties provides the storage for style information that is used by `StyleContext` and other `StyleProvider` implementations.

Before style properties can be stored in GtkStyleProperties, they must be registered with `gtk_style_properties_register_property()`.

Unless you are writing a `StyleProvider` implementation, you are unlikely to use this API directly, as `gtk_style_context_get()` and its variants are the preferred way to access styling information from widget implementations and theming engine implementations should use the APIs provided by `ThemingEngine` instead.

`StyleProperties` has been deprecated in GTK 3.16. The CSS machinery does not use it anymore and all users of this object have been deprecated.

Synopsis

- newtype StyleProperties = StyleProperties (ManagedPtr StyleProperties)
- class (GObject o, IsDescendantOf StyleProperties o) => IsStyleProperties o
- toStyleProperties :: (MonadIO m, IsStyleProperties o) => o -> m StyleProperties
- stylePropertiesClear :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> m ()
- stylePropertiesGetProperty :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> Text -> [StateFlags] -> m (Bool, GValue)
- stylePropertiesLookupColor :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> Text -> m SymbolicColor
- stylePropertiesMapColor :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> Text -> SymbolicColor -> m ()
- stylePropertiesMerge :: (HasCallStack, MonadIO m, IsStyleProperties a, IsStyleProperties b) => a -> b -> Bool -> m ()
- stylePropertiesNew :: (HasCallStack, MonadIO m) => m StyleProperties
- stylePropertiesSetProperty :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> Text -> [StateFlags] -> GValue -> m ()
- stylePropertiesUnsetProperty :: (HasCallStack, MonadIO m, IsStyleProperties a) => a -> Text -> [StateFlags] -> m ()

# Exported types

newtype StyleProperties Source #

Memory-managed wrapper type.

Constructors

StyleProperties (ManagedPtr StyleProperties) |

#### Instances

Instances details

Eq StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties Methods (==) :: StyleProperties -> StyleProperties -> Bool Source # (/=) :: StyleProperties -> StyleProperties -> Bool Source #
GObject StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties
ManagedPtrNewtype StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties Methods toManagedPtr :: StyleProperties -> ManagedPtr StyleProperties Source #
TypedObject StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties Methods glibType :: IO GType Source #
HasParentTypes StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties
IsGValue (Maybe StyleProperties) Source # | Convert `StyleProperties` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.StyleProperties Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe StyleProperties -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe StyleProperties) Source #
type ParentTypes StyleProperties Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties type ParentTypes StyleProperties = '[Object, StyleProvider]

class (GObject o, IsDescendantOf StyleProperties o) => IsStyleProperties o Source #

Type class for types which can be safely cast to `StyleProperties`, for instance with `toStyleProperties`.

#### Instances

Instances details

(GObject o, IsDescendantOf StyleProperties o) => IsStyleProperties o Source # |
Instance details Defined in GI.Gtk.Objects.StyleProperties

toStyleProperties :: (MonadIO m, IsStyleProperties o) => o -> m StyleProperties Source #

Cast to `StyleProperties`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, clear, forceFloating, freezeNotify, getv, isFloating, lookupColor, mapColor, merge, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, unsetProperty, watchClosure.

#### Getters

getData, getIconFactory, getProperty, getQdata, getStyle, getStyleProperty.

#### Setters

setData, setDataFull, setProperty.

## clear

stylePropertiesClear Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> m () |

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Clears all style information from `props`.

## getProperty

stylePropertiesGetProperty Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> Text | `property`: style property name
-> [StateFlags] | `state`: state to retrieve the property value for
-> m (Bool, GValue) | Returns: `True` if the property exists in `props`, `False` otherwise

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Gets a style property from `props` for the given state. When done with `value`, `valueUnset` needs to be called to free any allocated memory.

Since: 3.0

## lookupColor

stylePropertiesLookupColor Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> Text | `name`: color name to lookup
-> m SymbolicColor | Returns: The mapped color

Deprecated: (Since version 3.8)`SymbolicColor` is deprecated.

Returns the symbolic color that is mapped to `name`.

Since: 3.0

## mapColor

stylePropertiesMapColor Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> Text | `name`: color name
-> SymbolicColor | `color`: `SymbolicColor` to map `name` to
-> m () |

Deprecated: (Since version 3.8)`SymbolicColor` is deprecated.

Maps `color` so it can be referenced by `name`. See `stylePropertiesLookupColor`

Since: 3.0

## merge

stylePropertiesMerge Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a, IsStyleProperties b) |
=> a | `props`: a `StyleProperties`
-> b | `propsToMerge`: a second `StyleProperties`
-> Bool | `replace`: whether to replace values or not
-> m () |

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Merges into `props` all the style information contained in `propsToMerge`. If `replace` is `True`, the values will be overwritten, if it is `False`, the older values will prevail.

Since: 3.0

## new

stylePropertiesNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m StyleProperties | Returns: a new `StyleProperties`

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Returns a newly created `StyleProperties`

## setProperty

stylePropertiesSetProperty Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> Text | `property`: styling property to set
-> [StateFlags] | `state`: state to set the value for
-> GValue | `value`: new value for the property
-> m () |

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Sets a styling property in `props`.

Since: 3.0

## unsetProperty

stylePropertiesUnsetProperty Source #

Arguments

:: (HasCallStack, MonadIO m, IsStyleProperties a) |
=> a | `props`: a `StyleProperties`
-> Text | `property`: property to unset
-> [StateFlags] | `state`: state to unset
-> m () |

Deprecated: (Since version 3.16)`StyleProperties` are deprecated.

Unsets a style property in `props`.

Since: 3.0